class DefFile
  include Enumerable

  attr_reader :filename

  public
  def resetDef()
    loadDef()
  end

  public
  def dumpDef()
    raise RuntimeError.new( "Not implemented." )
  end

  public
  def each()
    @entry.each do |i|
      yield i
    end
  end

  protected
  def []( key = nil, n = nil )
    if ( key ) then
      if ( n ) then
      	if ( @data.has_key?( key )) then
      	  @data[ key ][ n-1 ]
      	else
	  nil
      	end
      else
      	@data[ key ]
      end
    else
      @data
    end
  end

  protected
  def []=( *array )
    value = array.pop
    case array.size
    when 2
      @data[ array[0] ][ array[1]-1 ] = value
    when 1
      @data[ array[0] ] = Array.new()
    else
      raise RuntimeError.new( "Unsupported binding style." )
    end
  end

  # Usage: To add new key and value, 
  #   self[ newKey() ] = newDefinitions
  protected
  def newKey()
    raise RuntimeError.new( "Not implemented." )
  end

  private
  def initialize( filename )
    @filename = filename
    @entry = nil
    @data = nil
    loadDef()
  end

  def loadDef()
    anArray = nil
    key = nil
    @entry = Array.new()
    @data = Hash.new()
    begin
      File.open( filename, "r" ).each do |line|
      	next if line =~ /^#/
      	anArray = line.chomp.split( "\t" )
      	key = anArray.shift
	@entry.push( key )
      	@data[ key ] = anArray
      end
    rescue
      raise RuntimeError.new( "Loading def-file failed." )
    end
  end
end
